/*
 * @author Venkat Subramaniam
 * DuraSoft, Inc.
 * http://www.durasoftcorp.com/download
 */

using System;
using System.Threading;

namespace WritingADelegate
{
	class User
	{
		class Beeper
		{
			public void beepReport(double amt)
			{
				Console.Write("\a");
			}
		}

		public static void highReport(double amt)
		{
			Console.WriteLine("New high price reported at " + 
				DateTime.Now.ToString() + ":" + amt);
		}

		public static void lowReport (double amt)
		{
			Console.WriteLine("New low price reported at " + 
				DateTime.Now.ToString() + ":" + amt);
		}

		static void Main(string[] args)
		{
			Beeper beeper = new Beeper();
			StockQuote stkQuote = new StockQuote();

			stkQuote.highDelegate += new StockQuoteDelegate(User.highReport);
			stkQuote.lowDelegate += new StockQuoteDelegate(User.lowReport);

			stkQuote.highDelegate += new StockQuoteDelegate(beeper.beepReport);
			stkQuote.lowDelegate += new StockQuoteDelegate(beeper.beepReport);

			Thread.Sleep(10000);
			Console.WriteLine("****** Will now turn off beeping");
			stkQuote.highDelegate -= new StockQuoteDelegate(beeper.beepReport);
			stkQuote.lowDelegate -= new StockQuoteDelegate(beeper.beepReport);

			Thread.Sleep(10000);
			Console.WriteLine("****** Will now turn on beeping");
			stkQuote.highDelegate += new StockQuoteDelegate(beeper.beepReport);
			stkQuote.lowDelegate += new StockQuoteDelegate(beeper.beepReport);
		}
	}
}
